#!/usr/bin/python

# This is how a client can send chunked HTTP data in a PUT without
# knowing the total length beforehand.  Nice.

import os
import sys
import pycurl
import time

class PostCallback:
    def __init__(self, iterable):
        self.iterator = iter(iterable)
        self.str = ""
    def read_function(self, size):
        time.sleep(1)
        while len(self.str) == 0:
            try:
                self.str = next(self.iterator)
            except StopIteration:
                return ""
        ret = self.str[0:size]
        self.str = self.str[size:]
        return ret

def my_gen():
    for word in "hello world good bye".split():
        print "yielding " + word
        yield word + "\n"

def write_function(buf):
    print "got " + str(len(buf)) + " bytes:"
    print buf

curl = pycurl.Curl()
curl.setopt(pycurl.URL, "http://localhost:1234/")
curl.setopt(pycurl.UPLOAD, 1)
curl.setopt(pycurl.READFUNCTION, PostCallback(my_gen()).read_function)
curl.setopt(pycurl.WRITEFUNCTION, write_function)
curl.perform()
curl.close()
